﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PureMVC.Interfaces;
using PureMVC.Patterns;
using WinFormTest.Mediators;
using WinFormTest.Model;

namespace WinFormTest.Controller
{
    public class StartupCommand:SimpleCommand, ICommand
    {
        /// <summary>
		/// Register the Proxies and Mediators.
		/// 
		/// Get the View Components for the Mediators from the app,
		/// which passed a reference to itself on the notification.
		/// </summary>
		/// <param name="note"></param>
		public override void Execute(INotification note)
		{
            Facade.RegisterProxy(new UserProxy());

            Form1 window = (Form1)note.Body;
          
            Facade.RegisterMediator(new UserListMediator(window.UserList));
            Facade.RegisterMediator(new UserAddMediator(window.UserAdd));
		}
    }
}
