﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PureMVC.Interfaces;
using PureMVC.Patterns;
using WinFormTest.Entity;
using WinFormTest.Model;
using WinFormTest.View;

namespace WinFormTest.Mediators
{
    public class UserAddMediator: Mediator, IMediator
    {
        private UserProxy _userProxy;

        public new const string NAME = "UserAddMediator";

        public UserAddMediator(UserAdd userAdd)
            :base(NAME, userAdd)
        {
            userAdd.AddUser += new EventHandler(userList_NewUser);
        }

        public override void OnRegister()
        {
            base.OnRegister();
            _userProxy = (UserProxy)Facade.RetrieveProxy(UserProxy.NAME);
        }

        private UserAdd UserAdd
        {
            get { return (UserAdd)ViewComponent; }
        }

        void userList_NewUser(object sender, EventArgs e)
        {
            var user = UserAdd.User;
            _userProxy.AddItem(user);
            SendNotification(ApplicationFacade.USER_ADDED, user);
            UserAdd.ClearForm();
        }

    }
}
