﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PureMVC.Interfaces;
using PureMVC.Patterns;
using WinFormTest.Entity;
using WinFormTest.Model;
using WinFormTest.View;

namespace WinFormTest.Mediators
{
    public class UserListMediator : Mediator, IMediator
    {
        private UserProxy _userProxy;

        public new const string NAME = "UserListMediator";

        public UserListMediator(UserList userList)
            : base(NAME, userList)
        {
      
        }

        public override void OnRegister()
        {
            base.OnRegister();
            _userProxy = (UserProxy)Facade.RetrieveProxy(UserProxy.NAME);
            UserList.LoadUsers(_userProxy.Users);
        }

        private UserList UserList
        {
            get { return (UserList)ViewComponent; }
        }

        void userList_NewUser(object sender, EventArgs e)
        {
            User user = new User();
            SendNotification(ApplicationFacade.NEW_USER, user);
        }

      public override IList<string> ListNotificationInterests()
        {
            IList<string> list = new List<string>();
            list.Add(ApplicationFacade.USER_ADDED);
            return list;
        }

        public override void HandleNotification(INotification note)
        {
            switch (note.Name)
            {
                case ApplicationFacade.USER_ADDED:
                    UserList.LoadUsers(_userProxy.Users);
                    break;
            }
        }
    }
}
