﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PureMVC.Interfaces;
using PureMVC.Patterns;
using WinFormTest.Entity;

using System.Collections.ObjectModel;

namespace WinFormTest.Model
{
    public class UserProxy:Proxy, IProxy
    {
	    public new const string NAME = "UserProxy";

		public UserProxy()
			: base(NAME, new ObservableCollection<User>())
		{
			// generate some test data			
		    AddItem(new User {Name = "Peter", Age = 29});
		}

		/// <summary>
		/// Return data property cast to proper type
		/// </summary>
		public IList<User> Users
		{
			get { return (IList<User>) Data; }
		}

		/// <summary>
		/// add an item to the data
		/// </summary>
		/// <param name="user"></param>
		public void AddItem(User user)
		{
			Users.Add(user);
		}

		/// <summary>
		/// update an item in the data
		/// </summary>
		/// <param name="user"></param>
		public void UpdateItem(User user)
		{
			for (int i = 0; i < Users.Count; i++)
			{
				if (Users[i].Name.Equals(user.Name))
				{
					Users[i] = user;
					break;
				}
			}
		}

		/// <summary>
		/// delete an item in the data
		/// </summary>
		/// <param name="user"></param>
		public void DeleteItem(User user)
		{
			for (int i = 0; i < Users.Count; i++)
			{
				if (Users[i].Name.Equals(user.Name))
				{
					Users.RemoveAt(i);
					break;
				}
			}
		}
    }
}
